#!/usr/bin/perl -w
# Quick Perl script to automate a CVS-style merge utility as described
# by Nick Bannon <nick@it.net.au>. Relies on the RCS utility merge,
# as well as diff, grep and cut. Probably would be more wholesome if done
# as a shell script. :)

use strict;

# requires two filename params
if (scalar(@ARGV) != 2) { die "$0 <file1> <file2>\n"; }

my $f1 = $ARGV[0];
my $f2 = $ARGV[1];
# original file name, should probably make it command-line option
my $orig = "$f1.original";

# grabs the larger line count of the two files.
my $size = &gtr(&lc($f1), &lc($f2));

system("diff -u$size $f1 $f2 | grep '^ ' | cut -c2- > $orig");
system("merge $f1 $orig $f2");

print "$f1 is now the merged file\n";
exit;

sub gtr {
	my $a = shift;
	my $b = shift;
	if ($a > $b) {
		return $a;
	} else {
		return $b;
	}
}

sub lc {
	my $file = shift;
	my $out = `wc -l $file`;
	$out =~ m/(\d+)/;
	return $1;
}
