/* pi.c
 */

#include "stdio.h"
#include "stdlib.h"
#include "stddef.h"
#include "math.h"


long int    x, f, i, iz, k, n;
long int    *a, *b;
double d, r, s, t;


void dump(void)
{
  long int r;
  
  printf("PI = 3.");
  r = 0;
  for(k=1; k<=x-2; k++) {
    printf("%05d ", b[k]);
  }
  printf("\n");
}


void sumtailor(void) {
  r = 0.0;
  s = 0.0;
  for (k=n; k<=x; k++) {
    r = (r*100000.0) + a[k];
    a[k] = r/d;
    r -= a[k]*d;
    s = (s*100000.0) + a[k];
    t = (double) ((long int) (s/i));
    s -= t*i;
    b[k] = b[k] + t*iz;
  }
  while ((a[n] == 0) && (n<x)) {
    n++;
  }
  
  for(k=x; k>=1; k--) {
    if (b[k] > 100000) {
      b[k] -= 100000;
      b[k-1] += 1;
    }
    if (b[k] < 0) {
      b[k] += 100000;
      b[k-1] -= 1;
    }
  }
}


void calc_pi(long int iz_w, long int f_w, double d_w)
{
  iz = iz_w;
  f  = f_w;
  d  = d_w;
  
  n = 0;
  i = 1;
  a[0] = d*f;
  d = d*d;
  for(k = 1; k<=x; k++) {
    a[k] = 0;
  }
  
  while (a[n] != 0) {
    sumtailor();
    i = i+2;
    iz = -iz;
  }
}


int main(void)
{
  printf("How many digits : ");
  scanf("%d", &x);
  x = (long int) ((double) x/5 + 2.85);
  a = (long int *) calloc(x+1, sizeof(long int)); /* for Borland C */
  b = (long int *) calloc(x+1, sizeof(long int));
  
  calc_pi( 1, 176,    57.0);
  calc_pi( 1,  28,   239.0);
  calc_pi(-1,  48,   682.0);
  calc_pi( 1,  96, 12943.0);
  dump();
  return 0;
}
