#!/usr/bin/perl -w
#    Simple script that reads the contents of a file into an array,
#    then shuffles the array and prints a number of lines.
#    (The lines are then random, but still unique)
#    Thanks NickB on #Debian
#
#    Usage: shuffle.pl < filename
#           shuffle.pl n filename1 filename2 ...
#
#    Was get8000.pl, now shuffle.pl
#
#    Copyright (C) 2000  Hkan Lindqvist <lindqvist@netstar.se>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

sub fisher_yates_shuffle {
	my $array = shift;
	my $i;
	for ($i = @$array; --$i; ) {
		my $j = int rand ($i+1);
		next if $i == $j;
		@$array[$i,$j] = @$array[$j,$i];
	}
}

$limit=shift;
@all = <>; #Yes, I am lazy, I know... :)

if (!defined($limit) || (--$limit >= $#all)) {
	$limit=$#all;
}

&fisher_yates_shuffle(\@all);

foreach $x (0..$limit) {
	print $all[$x];
}
